/* notification.c generated by valac 0.56.13, the Vala compiler
 * generated from notification.vala, do not modify */

/*
 * This file is part of budgie-desktop
 *
 * Copyright Budgie Desktop Developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#include "budgie-private.h"
#include <gio/gdesktopappinfo.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

enum  {
	BUDGIE_NOTIFICATION_0_PROPERTY,
	BUDGIE_NOTIFICATION_APP_INFO_PROPERTY,
	BUDGIE_NOTIFICATION_APP_ID_PROPERTY,
	BUDGIE_NOTIFICATION_URGENCY_PROPERTY,
	BUDGIE_NOTIFICATION_ID_PROPERTY,
	BUDGIE_NOTIFICATION_APP_NAME_PROPERTY,
	BUDGIE_NOTIFICATION_NOTIFICATION_ICON_PROPERTY,
	BUDGIE_NOTIFICATION_HINTS_PROPERTY,
	BUDGIE_NOTIFICATION_ACTIONS_PROPERTY,
	BUDGIE_NOTIFICATION_BODY_PROPERTY,
	BUDGIE_NOTIFICATION_SUMMARY_PROPERTY,
	BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY,
	BUDGIE_NOTIFICATION_CATEGORY_PROPERTY,
	BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY,
	BUDGIE_NOTIFICATION_APP_IMAGE_PROPERTY,
	BUDGIE_NOTIFICATION_IMAGE_PROPERTY,
	BUDGIE_NOTIFICATION_NUM_PROPERTIES
};
static GParamSpec* budgie_notification_properties[BUDGIE_NOTIFICATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _BudgieNotificationPrivate {
	GDesktopAppInfo* _app_info;
	gchar* _app_id;
	GNotificationPriority _urgency;
	guint32 _id;
	gchar* _app_name;
	gchar* _notification_icon;
	GHashTable* _hints;
	gchar** _actions;
	gint _actions_length1;
	gint __actions_size_;
	gchar* _body;
	gchar* _summary;
	guint _expire_timeout;
	gchar* _category;
	gint64 _timestamp;
	GtkImage* _app_image;
	GtkImage* _image;
};

static gint BudgieNotification_private_offset;
static gpointer budgie_notification_parent_class = NULL;
static GRegex* budgie_notification_entity_regex;
static GRegex* budgie_notification_entity_regex = NULL;
static GRegex* budgie_notification_tag_regex;
static GRegex* budgie_notification_tag_regex = NULL;

static GdkPixbuf* budgie_notification_decode_image (BudgieNotification* self,
                                             GVariant* img);
static gchar* budgie_notification_fix_markup (BudgieNotification* self,
                                       const gchar* markup);
static GtkImage* budgie_notification_get_appinfo_image (BudgieNotification* self,
                                                 GtkIconSize size,
                                                 const gchar* fallback);
static void budgie_notification_set_app_info (BudgieNotification* self,
                                       GDesktopAppInfo* value);
static void budgie_notification_set_app_id (BudgieNotification* self,
                                     const gchar* value);
static void budgie_notification_set_urgency (BudgieNotification* self,
                                      GNotificationPriority value);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static GObject * budgie_notification_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void budgie_notification_finalize (GObject * obj);
static GType budgie_notification_get_type_once (void);
static void _vala_budgie_notification_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_budgie_notification_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

/**
 * Enumeration of why a notification was closed.
 */
static GType
budgie_notification_close_reason_get_type_once (void)
{
	static const GEnumValue values[] = {{BUDGIE_NOTIFICATION_CLOSE_REASON_EXPIRED, "BUDGIE_NOTIFICATION_CLOSE_REASON_EXPIRED", "expired"}, {BUDGIE_NOTIFICATION_CLOSE_REASON_DISMISSED, "BUDGIE_NOTIFICATION_CLOSE_REASON_DISMISSED", "dismissed"}, {BUDGIE_NOTIFICATION_CLOSE_REASON_CLOSED, "BUDGIE_NOTIFICATION_CLOSE_REASON_CLOSED", "closed"}, {BUDGIE_NOTIFICATION_CLOSE_REASON_UNDEFINED, "BUDGIE_NOTIFICATION_CLOSE_REASON_UNDEFINED", "undefined"}, {0, NULL, NULL}};
	GType budgie_notification_close_reason_type_id;
	budgie_notification_close_reason_type_id = g_enum_register_static ("BudgieNotificationCloseReason", values);
	return budgie_notification_close_reason_type_id;
}

GType
budgie_notification_close_reason_get_type (void)
{
	static volatile gsize budgie_notification_close_reason_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_close_reason_type_id__once)) {
		GType budgie_notification_close_reason_type_id;
		budgie_notification_close_reason_type_id = budgie_notification_close_reason_get_type_once ();
		g_once_init_leave (&budgie_notification_close_reason_type_id__once, budgie_notification_close_reason_type_id);
	}
	return budgie_notification_close_reason_type_id__once;
}

/**
 * Enumeration of where notification popups will be shown.
 */
static GType
budgie_notification_position_get_type_once (void)
{
	static const GEnumValue values[] = {{BUDGIE_NOTIFICATION_POSITION_TOP_LEFT, "BUDGIE_NOTIFICATION_POSITION_TOP_LEFT", "top-left"}, {BUDGIE_NOTIFICATION_POSITION_TOP_RIGHT, "BUDGIE_NOTIFICATION_POSITION_TOP_RIGHT", "top-right"}, {BUDGIE_NOTIFICATION_POSITION_BOTTOM_LEFT, "BUDGIE_NOTIFICATION_POSITION_BOTTOM_LEFT", "bottom-left"}, {BUDGIE_NOTIFICATION_POSITION_BOTTOM_RIGHT, "BUDGIE_NOTIFICATION_POSITION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
	GType budgie_notification_position_type_id;
	budgie_notification_position_type_id = g_enum_register_static ("BudgieNotificationPosition", values);
	return budgie_notification_position_type_id;
}

GType
budgie_notification_position_get_type (void)
{
	static volatile gsize budgie_notification_position_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_position_type_id__once)) {
		GType budgie_notification_position_type_id;
		budgie_notification_position_type_id = budgie_notification_position_get_type_once ();
		g_once_init_leave (&budgie_notification_position_type_id__once, budgie_notification_position_type_id);
	}
	return budgie_notification_position_type_id__once;
}

static inline gpointer
budgie_notification_get_instance_private (BudgieNotification* self)
{
	return G_STRUCT_MEMBER_P (self, BudgieNotification_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 188 "notification.c"
}

BudgieNotification*
budgie_notification_construct (GType object_type,
                               guint32 id,
                               const gchar* app_name,
                               const gchar* notification_icon,
                               const gchar* summary,
                               const gchar* body,
                               gchar** actions,
                               gint actions_length1,
                               GHashTable* hints,
                               guint expire_timeout)
{
	BudgieNotification * self = NULL;
	gchar* name = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp4_;
#line 67 "../src/lib/notification.vala"
	g_return_val_if_fail (app_name != NULL, NULL);
#line 67 "../src/lib/notification.vala"
	g_return_val_if_fail (notification_icon != NULL, NULL);
#line 67 "../src/lib/notification.vala"
	g_return_val_if_fail (summary != NULL, NULL);
#line 67 "../src/lib/notification.vala"
	g_return_val_if_fail (body != NULL, NULL);
#line 67 "../src/lib/notification.vala"
	g_return_val_if_fail (hints != NULL, NULL);
#line 77 "../src/lib/notification.vala"
	_tmp0_ = g_strdup (app_name);
#line 77 "../src/lib/notification.vala"
	name = _tmp0_;
#line 79 "../src/lib/notification.vala"
	_tmp2_ = name;
#line 79 "../src/lib/notification.vala"
	if (string_contains (_tmp2_, "budgie")) {
#line 79 "../src/lib/notification.vala"
		_tmp1_ = string_contains (notification_icon, "caffeine");
#line 229 "notification.c"
	} else {
#line 79 "../src/lib/notification.vala"
		_tmp1_ = FALSE;
#line 233 "notification.c"
	}
#line 79 "../src/lib/notification.vala"
	if (_tmp1_) {
#line 237 "notification.c"
		gchar* _tmp3_;
#line 80 "../src/lib/notification.vala"
		_tmp3_ = g_strdup (_ ("Caffeine Mode"));
#line 80 "../src/lib/notification.vala"
		_g_free0 (name);
#line 80 "../src/lib/notification.vala"
		name = _tmp3_;
#line 245 "notification.c"
	}
#line 83 "../src/lib/notification.vala"
	_tmp4_ = name;
#line 83 "../src/lib/notification.vala"
	self = (BudgieNotification*) g_object_new (object_type, "id", id, "app-name", _tmp4_, "notification-icon", notification_icon, "summary", summary, "body", body, "actions", actions, "hints", hints, "expire-timeout", expire_timeout, NULL);
#line 67 "../src/lib/notification.vala"
	_g_free0 (name);
#line 67 "../src/lib/notification.vala"
	return self;
#line 255 "notification.c"
}

BudgieNotification*
budgie_notification_new (guint32 id,
                         const gchar* app_name,
                         const gchar* notification_icon,
                         const gchar* summary,
                         const gchar* body,
                         gchar** actions,
                         gint actions_length1,
                         GHashTable* hints,
                         guint expire_timeout)
{
#line 67 "../src/lib/notification.vala"
	return budgie_notification_construct (BUDGIE_TYPE_NOTIFICATION, id, app_name, notification_icon, summary, body, actions, actions_length1, hints, expire_timeout);
#line 271 "notification.c"
}

static GdkPixbuf*
budgie_notification_decode_image (BudgieNotification* self,
                                  GVariant* img)
{
	gint width = 0;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	gint _tmp2_;
	gint height = 0;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	gint _tmp5_;
	gint rowstride = 0;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	gint _tmp8_;
	gboolean has_alpha = FALSE;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	gboolean _tmp11_;
	gint bits_per_sample = 0;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	gint _tmp14_;
	guint8* raw = NULL;
	GVariant* _tmp15_;
	GVariant* _tmp16_;
	void* _tmp17_;
	guint8* _tmp18_;
	gint _tmp18__length1;
	gint raw_length1;
	gint _raw_size_;
	GdkPixbuf* pixbuf = NULL;
	guint8* _tmp19_;
	gint _tmp19__length1;
	GdkPixbuf* _tmp20_;
	GdkPixbuf* _tmp23_;
	GdkPixbuf* _tmp24_;
	GdkPixbuf* result;
#line 210 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 210 "../src/lib/notification.vala"
	g_return_val_if_fail (img != NULL, NULL);
#line 212 "../src/lib/notification.vala"
	_tmp0_ = g_variant_get_child_value (img, (gsize) 0);
#line 212 "../src/lib/notification.vala"
	_tmp1_ = _tmp0_;
#line 212 "../src/lib/notification.vala"
	_tmp2_ = (gint) g_variant_get_int32 (_tmp1_);
#line 212 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp1_);
#line 212 "../src/lib/notification.vala"
	width = _tmp2_;
#line 213 "../src/lib/notification.vala"
	_tmp3_ = g_variant_get_child_value (img, (gsize) 1);
#line 213 "../src/lib/notification.vala"
	_tmp4_ = _tmp3_;
#line 213 "../src/lib/notification.vala"
	_tmp5_ = (gint) g_variant_get_int32 (_tmp4_);
#line 213 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp4_);
#line 213 "../src/lib/notification.vala"
	height = _tmp5_;
#line 214 "../src/lib/notification.vala"
	_tmp6_ = g_variant_get_child_value (img, (gsize) 2);
#line 214 "../src/lib/notification.vala"
	_tmp7_ = _tmp6_;
#line 214 "../src/lib/notification.vala"
	_tmp8_ = (gint) g_variant_get_int32 (_tmp7_);
#line 214 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp7_);
#line 214 "../src/lib/notification.vala"
	rowstride = _tmp8_;
#line 215 "../src/lib/notification.vala"
	_tmp9_ = g_variant_get_child_value (img, (gsize) 3);
#line 215 "../src/lib/notification.vala"
	_tmp10_ = _tmp9_;
#line 215 "../src/lib/notification.vala"
	_tmp11_ = g_variant_get_boolean (_tmp10_);
#line 215 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp10_);
#line 215 "../src/lib/notification.vala"
	has_alpha = _tmp11_;
#line 216 "../src/lib/notification.vala"
	_tmp12_ = g_variant_get_child_value (img, (gsize) 4);
#line 216 "../src/lib/notification.vala"
	_tmp13_ = _tmp12_;
#line 216 "../src/lib/notification.vala"
	_tmp14_ = (gint) g_variant_get_int32 (_tmp13_);
#line 216 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp13_);
#line 216 "../src/lib/notification.vala"
	bits_per_sample = _tmp14_;
#line 218 "../src/lib/notification.vala"
	_tmp15_ = g_variant_get_child_value (img, (gsize) 6);
#line 218 "../src/lib/notification.vala"
	_tmp16_ = _tmp15_;
#line 218 "../src/lib/notification.vala"
	_tmp17_ = g_variant_get_data (_tmp16_);
#line 218 "../src/lib/notification.vala"
	_tmp18_ = (guint8*) _tmp17_;
#line 218 "../src/lib/notification.vala"
	_tmp18__length1 = -1;
#line 218 "../src/lib/notification.vala"
	_g_variant_unref0 (_tmp16_);
#line 218 "../src/lib/notification.vala"
	raw = _tmp18_;
#line 218 "../src/lib/notification.vala"
	raw_length1 = _tmp18__length1;
#line 218 "../src/lib/notification.vala"
	_raw_size_ = raw_length1;
#line 221 "../src/lib/notification.vala"
	_tmp19_ = raw;
#line 221 "../src/lib/notification.vala"
	_tmp19__length1 = raw_length1;
#line 221 "../src/lib/notification.vala"
	_tmp20_ = gdk_pixbuf_new_from_data (_tmp19_, GDK_COLORSPACE_RGB, has_alpha, bits_per_sample, width, height, rowstride, (GdkPixbufDestroyNotify) NULL, NULL);
#line 221 "../src/lib/notification.vala"
	pixbuf = _tmp20_;
#line 232 "../src/lib/notification.vala"
	if (height != 48) {
#line 395 "notification.c"
		GdkPixbuf* _tmp21_;
		GdkPixbuf* _tmp22_;
#line 233 "../src/lib/notification.vala"
		_tmp21_ = pixbuf;
#line 233 "../src/lib/notification.vala"
		_tmp22_ = gdk_pixbuf_scale_simple (_tmp21_, 48, 48, GDK_INTERP_BILINEAR);
#line 233 "../src/lib/notification.vala"
		_g_object_unref0 (pixbuf);
#line 233 "../src/lib/notification.vala"
		pixbuf = _tmp22_;
#line 406 "notification.c"
	}
#line 236 "../src/lib/notification.vala"
	_tmp23_ = pixbuf;
#line 236 "../src/lib/notification.vala"
	_tmp24_ = gdk_pixbuf_copy (_tmp23_);
#line 236 "../src/lib/notification.vala"
	result = _tmp24_;
#line 236 "../src/lib/notification.vala"
	_g_object_unref0 (pixbuf);
#line 236 "../src/lib/notification.vala"
	return result;
#line 418 "notification.c"
}

/**
 * Taken from gnome-shell. Notification markup is always a mess, and this is cleaner
 * than our previous solution.
 */
static gchar*
budgie_notification_fix_markup (BudgieNotification* self,
                                const gchar* markup)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 243 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 243 "../src/lib/notification.vala"
	g_return_val_if_fail (markup != NULL, NULL);
#line 244 "../src/lib/notification.vala"
	_tmp0_ = g_strdup (markup);
#line 244 "../src/lib/notification.vala"
	text = _tmp0_;
#line 441 "notification.c"
	{
		gchar* _tmp1_ = NULL;
		GRegex* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 247 "../src/lib/notification.vala"
		_tmp2_ = budgie_notification_entity_regex;
#line 247 "../src/lib/notification.vala"
		_tmp3_ = strlen (markup);
#line 247 "../src/lib/notification.vala"
		_tmp4_ = _tmp3_;
#line 247 "../src/lib/notification.vala"
		_tmp5_ = g_regex_replace (_tmp2_, markup, (gssize) _tmp4_, 0, "&amp;", 0, &_inner_error0_);
#line 247 "../src/lib/notification.vala"
		_tmp1_ = _tmp5_;
#line 247 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 469 "notification.c"
			goto __catch0_g_error;
		}
#line 247 "../src/lib/notification.vala"
		_tmp6_ = _tmp1_;
#line 247 "../src/lib/notification.vala"
		_tmp1_ = NULL;
#line 247 "../src/lib/notification.vala"
		_g_free0 (text);
#line 247 "../src/lib/notification.vala"
		text = _tmp6_;
#line 248 "../src/lib/notification.vala"
		_tmp8_ = budgie_notification_tag_regex;
#line 248 "../src/lib/notification.vala"
		_tmp9_ = text;
#line 248 "../src/lib/notification.vala"
		_tmp10_ = text;
#line 248 "../src/lib/notification.vala"
		_tmp11_ = strlen (_tmp10_);
#line 248 "../src/lib/notification.vala"
		_tmp12_ = _tmp11_;
#line 248 "../src/lib/notification.vala"
		_tmp13_ = g_regex_replace (_tmp8_, _tmp9_, (gssize) _tmp12_, 0, "&lt;", 0, &_inner_error0_);
#line 248 "../src/lib/notification.vala"
		_tmp7_ = _tmp13_;
#line 248 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 248 "../src/lib/notification.vala"
			_g_free0 (_tmp1_);
#line 498 "notification.c"
			goto __catch0_g_error;
		}
#line 248 "../src/lib/notification.vala"
		_tmp14_ = _tmp7_;
#line 248 "../src/lib/notification.vala"
		_tmp7_ = NULL;
#line 248 "../src/lib/notification.vala"
		_g_free0 (text);
#line 248 "../src/lib/notification.vala"
		text = _tmp14_;
#line 246 "../src/lib/notification.vala"
		_g_free0 (_tmp7_);
#line 246 "../src/lib/notification.vala"
		_g_free0 (_tmp1_);
#line 513 "notification.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 246 "../src/lib/notification.vala"
		e = _inner_error0_;
#line 246 "../src/lib/notification.vala"
		_inner_error0_ = NULL;
#line 250 "../src/lib/notification.vala"
		_tmp15_ = e;
#line 250 "../src/lib/notification.vala"
		_tmp16_ = _tmp15_->message;
#line 250 "../src/lib/notification.vala"
		g_warning ("notification.vala:250: Invalid regex: %s", _tmp16_);
#line 246 "../src/lib/notification.vala"
		_g_error_free0 (e);
#line 533 "notification.c"
	}
	__finally0:
#line 246 "../src/lib/notification.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 246 "../src/lib/notification.vala"
		_g_free0 (text);
#line 246 "../src/lib/notification.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 246 "../src/lib/notification.vala"
		g_clear_error (&_inner_error0_);
#line 246 "../src/lib/notification.vala"
		return NULL;
#line 546 "notification.c"
	}
#line 253 "../src/lib/notification.vala"
	result = text;
#line 253 "../src/lib/notification.vala"
	return result;
#line 552 "notification.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 260 "../src/lib/notification.vala"
	return self ? g_object_ref (self) : NULL;
#line 560 "notification.c"
}

static GtkImage*
budgie_notification_get_appinfo_image (BudgieNotification* self,
                                       GtkIconSize size,
                                       const gchar* fallback)
{
	GDesktopAppInfo* _tmp0_;
	gchar* app_icon_name = NULL;
	GDesktopAppInfo* _tmp21_;
	gchar* _tmp22_;
	GIcon* app_icon = NULL;
	GDesktopAppInfo* _tmp23_;
	GIcon* _tmp24_;
	GIcon* _tmp25_;
	const gchar* _tmp26_;
	GtkImage* result;
#line 256 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 257 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_info;
#line 257 "../src/lib/notification.vala"
	if (_tmp0_ == NULL) {
#line 584 "notification.c"
		GtkImage* fallback_image = NULL;
		GtkImage* _tmp1_;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		GtkImage* _tmp5_;
		gboolean invalid_image = FALSE;
		GtkImage* _tmp18_ = NULL;
		GtkImage* _tmp20_;
#line 258 "../src/lib/notification.vala"
		_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name (fallback, (GtkIconSize) size);
#line 258 "../src/lib/notification.vala"
		g_object_ref_sink (_tmp1_);
#line 258 "../src/lib/notification.vala"
		fallback_image = _tmp1_;
#line 259 "../src/lib/notification.vala"
		_tmp5_ = fallback_image;
#line 259 "../src/lib/notification.vala"
		if (_tmp5_ == NULL) {
#line 259 "../src/lib/notification.vala"
			_tmp4_ = TRUE;
#line 606 "notification.c"
		} else {
			GtkImage* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 259 "../src/lib/notification.vala"
			_tmp6_ = fallback_image;
#line 259 "../src/lib/notification.vala"
			g_object_get (_tmp6_, "icon-name", &_tmp7_, NULL);
#line 259 "../src/lib/notification.vala"
			_tmp8_ = _tmp7_;
#line 259 "../src/lib/notification.vala"
			_tmp9_ = _tmp8_;
#line 259 "../src/lib/notification.vala"
			_tmp4_ = _tmp9_ == NULL;
#line 259 "../src/lib/notification.vala"
			_g_free0 (_tmp9_);
#line 624 "notification.c"
		}
#line 259 "../src/lib/notification.vala"
		if (_tmp4_) {
#line 259 "../src/lib/notification.vala"
			_tmp3_ = TRUE;
#line 630 "notification.c"
		} else {
			GtkImage* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
#line 259 "../src/lib/notification.vala"
			_tmp10_ = fallback_image;
#line 259 "../src/lib/notification.vala"
			g_object_get (_tmp10_, "icon-name", &_tmp11_, NULL);
#line 259 "../src/lib/notification.vala"
			_tmp12_ = _tmp11_;
#line 259 "../src/lib/notification.vala"
			_tmp13_ = _tmp12_;
#line 259 "../src/lib/notification.vala"
			_tmp3_ = g_strcmp0 (_tmp13_, "image-missing") == 0;
#line 259 "../src/lib/notification.vala"
			_g_free0 (_tmp13_);
#line 648 "notification.c"
		}
#line 259 "../src/lib/notification.vala"
		if (_tmp3_) {
#line 259 "../src/lib/notification.vala"
			_tmp2_ = TRUE;
#line 654 "notification.c"
		} else {
			GtkImage* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 259 "../src/lib/notification.vala"
			_tmp14_ = fallback_image;
#line 259 "../src/lib/notification.vala"
			g_object_get (_tmp14_, "icon-name", &_tmp15_, NULL);
#line 259 "../src/lib/notification.vala"
			_tmp16_ = _tmp15_;
#line 259 "../src/lib/notification.vala"
			_tmp17_ = _tmp16_;
#line 259 "../src/lib/notification.vala"
			_tmp2_ = g_strcmp0 (_tmp17_, "") == 0;
#line 259 "../src/lib/notification.vala"
			_g_free0 (_tmp17_);
#line 672 "notification.c"
		}
#line 259 "../src/lib/notification.vala"
		invalid_image = _tmp2_;
#line 260 "../src/lib/notification.vala"
		if (invalid_image) {
#line 260 "../src/lib/notification.vala"
			_tmp18_ = NULL;
#line 680 "notification.c"
		} else {
			GtkImage* _tmp19_;
#line 260 "../src/lib/notification.vala"
			_tmp19_ = fallback_image;
#line 260 "../src/lib/notification.vala"
			_tmp18_ = _tmp19_;
#line 687 "notification.c"
		}
#line 260 "../src/lib/notification.vala"
		_tmp20_ = _g_object_ref0 (_tmp18_);
#line 260 "../src/lib/notification.vala"
		result = _tmp20_;
#line 260 "../src/lib/notification.vala"
		_g_object_unref0 (fallback_image);
#line 260 "../src/lib/notification.vala"
		return result;
#line 697 "notification.c"
	}
#line 263 "../src/lib/notification.vala"
	_tmp21_ = self->priv->_app_info;
#line 263 "../src/lib/notification.vala"
	_tmp22_ = g_desktop_app_info_get_string (_tmp21_, "Icon");
#line 263 "../src/lib/notification.vala"
	app_icon_name = _tmp22_;
#line 264 "../src/lib/notification.vala"
	_tmp23_ = self->priv->_app_info;
#line 264 "../src/lib/notification.vala"
	_tmp24_ = g_app_info_get_icon ((GAppInfo*) _tmp23_);
#line 264 "../src/lib/notification.vala"
	_tmp25_ = _g_object_ref0 (_tmp24_);
#line 264 "../src/lib/notification.vala"
	app_icon = _tmp25_;
#line 266 "../src/lib/notification.vala"
	_tmp26_ = app_icon_name;
#line 266 "../src/lib/notification.vala"
	if (_tmp26_ != NULL) {
#line 717 "notification.c"
		const gchar* _tmp27_;
		GtkImage* _tmp28_;
#line 267 "../src/lib/notification.vala"
		_tmp27_ = app_icon_name;
#line 267 "../src/lib/notification.vala"
		_tmp28_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp27_, (GtkIconSize) size);
#line 267 "../src/lib/notification.vala"
		g_object_ref_sink (_tmp28_);
#line 267 "../src/lib/notification.vala"
		result = _tmp28_;
#line 267 "../src/lib/notification.vala"
		_g_object_unref0 (app_icon);
#line 267 "../src/lib/notification.vala"
		_g_free0 (app_icon_name);
#line 267 "../src/lib/notification.vala"
		return result;
#line 734 "notification.c"
	} else {
		gboolean _tmp29_ = FALSE;
		const gchar* _tmp30_;
#line 268 "../src/lib/notification.vala"
		_tmp30_ = app_icon_name;
#line 268 "../src/lib/notification.vala"
		if (_tmp30_ == NULL) {
#line 742 "notification.c"
			GIcon* _tmp31_;
#line 268 "../src/lib/notification.vala"
			_tmp31_ = app_icon;
#line 268 "../src/lib/notification.vala"
			_tmp29_ = _tmp31_ != NULL;
#line 748 "notification.c"
		} else {
#line 268 "../src/lib/notification.vala"
			_tmp29_ = FALSE;
#line 752 "notification.c"
		}
#line 268 "../src/lib/notification.vala"
		if (_tmp29_) {
#line 756 "notification.c"
			GIcon* _tmp32_;
			GtkImage* _tmp33_;
#line 269 "../src/lib/notification.vala"
			_tmp32_ = app_icon;
#line 269 "../src/lib/notification.vala"
			_tmp33_ = (GtkImage*) gtk_image_new_from_gicon (_tmp32_, (GtkIconSize) size);
#line 269 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp33_);
#line 269 "../src/lib/notification.vala"
			result = _tmp33_;
#line 269 "../src/lib/notification.vala"
			_g_object_unref0 (app_icon);
#line 269 "../src/lib/notification.vala"
			_g_free0 (app_icon_name);
#line 269 "../src/lib/notification.vala"
			return result;
#line 773 "notification.c"
		}
	}
#line 272 "../src/lib/notification.vala"
	result = NULL;
#line 272 "../src/lib/notification.vala"
	_g_object_unref0 (app_icon);
#line 272 "../src/lib/notification.vala"
	_g_free0 (app_icon_name);
#line 272 "../src/lib/notification.vala"
	return result;
#line 784 "notification.c"
}

GDesktopAppInfo*
budgie_notification_get_app_info (BudgieNotification* self)
{
	GDesktopAppInfo* result;
	GDesktopAppInfo* _tmp0_;
#line 42 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_info;
#line 42 "../src/lib/notification.vala"
	result = _tmp0_;
#line 42 "../src/lib/notification.vala"
	return result;
#line 800 "notification.c"
}

static void
budgie_notification_set_app_info (BudgieNotification* self,
                                  GDesktopAppInfo* value)
{
	GDesktopAppInfo* old_value;
#line 42 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_info (self);
#line 42 "../src/lib/notification.vala"
	if (old_value != value) {
#line 814 "notification.c"
		GDesktopAppInfo* _tmp0_;
#line 42 "../src/lib/notification.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 42 "../src/lib/notification.vala"
		_g_object_unref0 (self->priv->_app_info);
#line 42 "../src/lib/notification.vala"
		self->priv->_app_info = _tmp0_;
#line 42 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_INFO_PROPERTY]);
#line 824 "notification.c"
	}
}

const gchar*
budgie_notification_get_app_id (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 43 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_id;
#line 43 "../src/lib/notification.vala"
	result = _tmp0_;
#line 43 "../src/lib/notification.vala"
	return result;
#line 841 "notification.c"
}

static void
budgie_notification_set_app_id (BudgieNotification* self,
                                const gchar* value)
{
	gchar* old_value;
#line 43 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_id (self);
#line 43 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 855 "notification.c"
		gchar* _tmp0_;
#line 43 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 43 "../src/lib/notification.vala"
		_g_free0 (self->priv->_app_id);
#line 43 "../src/lib/notification.vala"
		self->priv->_app_id = _tmp0_;
#line 43 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_ID_PROPERTY]);
#line 865 "notification.c"
	}
}

GNotificationPriority
budgie_notification_get_urgency (BudgieNotification* self)
{
	GNotificationPriority result;
#line 44 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "../src/lib/notification.vala"
	result = self->priv->_urgency;
#line 44 "../src/lib/notification.vala"
	return result;
#line 879 "notification.c"
}

static void
budgie_notification_set_urgency (BudgieNotification* self,
                                 GNotificationPriority value)
{
	GNotificationPriority old_value;
#line 44 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/lib/notification.vala"
	old_value = budgie_notification_get_urgency (self);
#line 44 "../src/lib/notification.vala"
	if (old_value != value) {
#line 44 "../src/lib/notification.vala"
		self->priv->_urgency = value;
#line 44 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_URGENCY_PROPERTY]);
#line 897 "notification.c"
	}
}

guint32
budgie_notification_get_id (BudgieNotification* self)
{
	guint32 result;
#line 46 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 46 "../src/lib/notification.vala"
	result = self->priv->_id;
#line 46 "../src/lib/notification.vala"
	return result;
#line 911 "notification.c"
}

static void
budgie_notification_set_id (BudgieNotification* self,
                            guint32 value)
{
	guint32 old_value;
#line 46 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/lib/notification.vala"
	old_value = budgie_notification_get_id (self);
#line 46 "../src/lib/notification.vala"
	if (old_value != value) {
#line 46 "../src/lib/notification.vala"
		self->priv->_id = value;
#line 46 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_ID_PROPERTY]);
#line 929 "notification.c"
	}
}

const gchar*
budgie_notification_get_app_name (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_name;
#line 49 "../src/lib/notification.vala"
	result = _tmp0_;
#line 49 "../src/lib/notification.vala"
	return result;
#line 946 "notification.c"
}

static void
budgie_notification_set_app_name (BudgieNotification* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 49 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_name (self);
#line 49 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 960 "notification.c"
		gchar* _tmp0_;
#line 49 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 49 "../src/lib/notification.vala"
		_g_free0 (self->priv->_app_name);
#line 49 "../src/lib/notification.vala"
		self->priv->_app_name = _tmp0_;
#line 49 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_NAME_PROPERTY]);
#line 970 "notification.c"
	}
}

const gchar*
budgie_notification_get_notification_icon (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_notification_icon;
#line 50 "../src/lib/notification.vala"
	result = _tmp0_;
#line 50 "../src/lib/notification.vala"
	return result;
#line 987 "notification.c"
}

static void
budgie_notification_set_notification_icon (BudgieNotification* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 50 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/lib/notification.vala"
	old_value = budgie_notification_get_notification_icon (self);
#line 50 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1001 "notification.c"
		gchar* _tmp0_;
#line 50 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 50 "../src/lib/notification.vala"
		_g_free0 (self->priv->_notification_icon);
#line 50 "../src/lib/notification.vala"
		self->priv->_notification_icon = _tmp0_;
#line 50 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_NOTIFICATION_ICON_PROPERTY]);
#line 1011 "notification.c"
	}
}

GHashTable*
budgie_notification_get_hints (BudgieNotification* self)
{
	GHashTable* result;
	GHashTable* _tmp0_;
#line 51 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_hints;
#line 51 "../src/lib/notification.vala"
	result = _tmp0_;
#line 51 "../src/lib/notification.vala"
	return result;
#line 1028 "notification.c"
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 51 "../src/lib/notification.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 1036 "notification.c"
}

static void
budgie_notification_set_hints (BudgieNotification* self,
                               GHashTable* value)
{
	GHashTable* old_value;
#line 51 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/lib/notification.vala"
	old_value = budgie_notification_get_hints (self);
#line 51 "../src/lib/notification.vala"
	if (old_value != value) {
#line 1050 "notification.c"
		GHashTable* _tmp0_;
#line 51 "../src/lib/notification.vala"
		_tmp0_ = _g_hash_table_ref0 (value);
#line 51 "../src/lib/notification.vala"
		_g_hash_table_unref0 (self->priv->_hints);
#line 51 "../src/lib/notification.vala"
		self->priv->_hints = _tmp0_;
#line 51 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_HINTS_PROPERTY]);
#line 1060 "notification.c"
	}
}

gchar**
budgie_notification_get_actions (BudgieNotification* self,
                                 gint* result_length1)
{
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 52 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_actions;
#line 52 "../src/lib/notification.vala"
	_tmp0__length1 = self->priv->_actions_length1;
#line 52 "../src/lib/notification.vala"
	_tmp1_ = _tmp0_;
#line 52 "../src/lib/notification.vala"
	_tmp1__length1 = _tmp0__length1;
#line 52 "../src/lib/notification.vala"
	if (result_length1) {
#line 52 "../src/lib/notification.vala"
		*result_length1 = _tmp1__length1;
#line 1087 "notification.c"
	}
#line 52 "../src/lib/notification.vala"
	result = _tmp1_;
#line 52 "../src/lib/notification.vala"
	return result;
#line 1093 "notification.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 52 "../src/lib/notification.vala"
	if (length >= 0) {
#line 1102 "notification.c"
		gchar** result;
		gssize i;
#line 52 "../src/lib/notification.vala"
		result = g_new0 (gchar*, length + 1);
#line 52 "../src/lib/notification.vala"
		for (i = 0; i < length; i++) {
#line 1109 "notification.c"
			gchar* _tmp0_;
#line 52 "../src/lib/notification.vala"
			_tmp0_ = g_strdup (self[i]);
#line 52 "../src/lib/notification.vala"
			result[i] = _tmp0_;
#line 1115 "notification.c"
		}
#line 52 "../src/lib/notification.vala"
		return result;
#line 1119 "notification.c"
	}
#line 52 "../src/lib/notification.vala"
	return NULL;
#line 1123 "notification.c"
}

static void
budgie_notification_set_actions (BudgieNotification* self,
                                 gchar** value,
                                 gint value_length1)
{
	gchar** old_value;
	gint old_value_length;
#line 52 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/lib/notification.vala"
	old_value = budgie_notification_get_actions (self, &old_value_length);
#line 52 "../src/lib/notification.vala"
	if (old_value != value) {
#line 1139 "notification.c"
		gchar** _tmp0_;
		gint _tmp0__length1;
#line 52 "../src/lib/notification.vala"
		_tmp0_ = (value != NULL) ? _vala_array_dup1 (value, value_length1) : value;
#line 52 "../src/lib/notification.vala"
		_tmp0__length1 = value_length1;
#line 52 "../src/lib/notification.vala"
		self->priv->_actions = (_vala_array_free (self->priv->_actions, self->priv->_actions_length1, (GDestroyNotify) g_free), NULL);
#line 52 "../src/lib/notification.vala"
		self->priv->_actions = _tmp0_;
#line 52 "../src/lib/notification.vala"
		self->priv->_actions_length1 = _tmp0__length1;
#line 52 "../src/lib/notification.vala"
		self->priv->__actions_size_ = self->priv->_actions_length1;
#line 52 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_ACTIONS_PROPERTY]);
#line 1156 "notification.c"
	}
}

const gchar*
budgie_notification_get_body (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 53 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_body;
#line 53 "../src/lib/notification.vala"
	result = _tmp0_;
#line 53 "../src/lib/notification.vala"
	return result;
#line 1173 "notification.c"
}

void
budgie_notification_set_body (BudgieNotification* self,
                              const gchar* value)
{
	gchar* old_value;
#line 53 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/lib/notification.vala"
	old_value = budgie_notification_get_body (self);
#line 53 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1187 "notification.c"
		gchar* _tmp0_;
#line 53 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 53 "../src/lib/notification.vala"
		_g_free0 (self->priv->_body);
#line 53 "../src/lib/notification.vala"
		self->priv->_body = _tmp0_;
#line 53 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_BODY_PROPERTY]);
#line 1197 "notification.c"
	}
}

const gchar*
budgie_notification_get_summary (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 54 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_summary;
#line 54 "../src/lib/notification.vala"
	result = _tmp0_;
#line 54 "../src/lib/notification.vala"
	return result;
#line 1214 "notification.c"
}

void
budgie_notification_set_summary (BudgieNotification* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 54 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/lib/notification.vala"
	old_value = budgie_notification_get_summary (self);
#line 54 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1228 "notification.c"
		gchar* _tmp0_;
#line 54 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 54 "../src/lib/notification.vala"
		_g_free0 (self->priv->_summary);
#line 54 "../src/lib/notification.vala"
		self->priv->_summary = _tmp0_;
#line 54 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_SUMMARY_PROPERTY]);
#line 1238 "notification.c"
	}
}

guint
budgie_notification_get_expire_timeout (BudgieNotification* self)
{
	guint result;
#line 55 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 55 "../src/lib/notification.vala"
	result = self->priv->_expire_timeout;
#line 55 "../src/lib/notification.vala"
	return result;
#line 1252 "notification.c"
}

void
budgie_notification_set_expire_timeout (BudgieNotification* self,
                                        guint value)
{
	guint old_value;
#line 55 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/lib/notification.vala"
	old_value = budgie_notification_get_expire_timeout (self);
#line 55 "../src/lib/notification.vala"
	if (old_value != value) {
#line 55 "../src/lib/notification.vala"
		self->priv->_expire_timeout = value;
#line 55 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY]);
#line 1270 "notification.c"
	}
}

const gchar*
budgie_notification_get_category (BudgieNotification* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 57 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 57 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_category;
#line 57 "../src/lib/notification.vala"
	result = _tmp0_;
#line 57 "../src/lib/notification.vala"
	return result;
#line 1287 "notification.c"
}

void
budgie_notification_set_category (BudgieNotification* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 57 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/lib/notification.vala"
	old_value = budgie_notification_get_category (self);
#line 57 "../src/lib/notification.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1301 "notification.c"
		gchar* _tmp0_;
#line 57 "../src/lib/notification.vala"
		_tmp0_ = g_strdup (value);
#line 57 "../src/lib/notification.vala"
		_g_free0 (self->priv->_category);
#line 57 "../src/lib/notification.vala"
		self->priv->_category = _tmp0_;
#line 57 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_CATEGORY_PROPERTY]);
#line 1311 "notification.c"
	}
}

gint64
budgie_notification_get_timestamp (BudgieNotification* self)
{
	gint64 result;
#line 58 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 58 "../src/lib/notification.vala"
	result = self->priv->_timestamp;
#line 58 "../src/lib/notification.vala"
	return result;
#line 1325 "notification.c"
}

void
budgie_notification_set_timestamp (BudgieNotification* self,
                                   gint64 value)
{
	gint64 old_value;
#line 58 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/lib/notification.vala"
	old_value = budgie_notification_get_timestamp (self);
#line 58 "../src/lib/notification.vala"
	if (old_value != value) {
#line 58 "../src/lib/notification.vala"
		self->priv->_timestamp = value;
#line 58 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY]);
#line 1343 "notification.c"
	}
}

GtkImage*
budgie_notification_get_app_image (BudgieNotification* self)
{
	GtkImage* result;
	GtkImage* _tmp0_;
#line 61 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_app_image;
#line 61 "../src/lib/notification.vala"
	result = _tmp0_;
#line 61 "../src/lib/notification.vala"
	return result;
#line 1360 "notification.c"
}

void
budgie_notification_set_app_image (BudgieNotification* self,
                                   GtkImage* value)
{
	GtkImage* old_value;
#line 61 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/lib/notification.vala"
	old_value = budgie_notification_get_app_image (self);
#line 61 "../src/lib/notification.vala"
	if (old_value != value) {
#line 1374 "notification.c"
		GtkImage* _tmp0_;
#line 61 "../src/lib/notification.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 61 "../src/lib/notification.vala"
		_g_object_unref0 (self->priv->_app_image);
#line 61 "../src/lib/notification.vala"
		self->priv->_app_image = _tmp0_;
#line 61 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_IMAGE_PROPERTY]);
#line 1384 "notification.c"
	}
}

GtkImage*
budgie_notification_get_image (BudgieNotification* self)
{
	GtkImage* result;
	GtkImage* _tmp0_;
#line 62 "../src/lib/notification.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../src/lib/notification.vala"
	_tmp0_ = self->priv->_image;
#line 62 "../src/lib/notification.vala"
	result = _tmp0_;
#line 62 "../src/lib/notification.vala"
	return result;
#line 1401 "notification.c"
}

void
budgie_notification_set_image (BudgieNotification* self,
                               GtkImage* value)
{
	GtkImage* old_value;
#line 62 "../src/lib/notification.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/lib/notification.vala"
	old_value = budgie_notification_get_image (self);
#line 62 "../src/lib/notification.vala"
	if (old_value != value) {
#line 1415 "notification.c"
		GtkImage* _tmp0_;
#line 62 "../src/lib/notification.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 62 "../src/lib/notification.vala"
		_g_object_unref0 (self->priv->_image);
#line 62 "../src/lib/notification.vala"
		self->priv->_image = _tmp0_;
#line 62 "../src/lib/notification.vala"
		g_object_notify_by_pspec ((GObject *) self, budgie_notification_properties[BUDGIE_NOTIFICATION_IMAGE_PROPERTY]);
#line 1425 "notification.c"
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1448 "notification.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1452 "notification.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1458 "notification.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1462 "notification.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1466 "notification.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 1474 "notification.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1502 "notification.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 1511 "notification.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1525 "notification.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 1534 "notification.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 1548 "notification.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1557 "notification.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 1566 "notification.c"
}

static GObject *
budgie_notification_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BudgieNotification * self;
	GVariant* variant = NULL;
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GHashTable* _tmp5_;
	gconstpointer _tmp6_;
	GVariant* _tmp7_;
	gboolean _tmp11_ = FALSE;
	GHashTable* _tmp12_;
	gconstpointer _tmp13_;
	GVariant* _tmp14_;
	gboolean _tmp19_ = FALSE;
	GHashTable* _tmp20_;
	gconstpointer _tmp21_;
	GVariant* _tmp22_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	GtkImage* _tmp44_;
	GtkImage* _tmp45_;
	gboolean image_found = FALSE;
	gboolean _tmp46_ = FALSE;
	GHashTable* _tmp47_;
	gconstpointer _tmp48_;
	GVariant* _tmp49_;
	gboolean _tmp59_ = FALSE;
	gboolean _tmp110_ = FALSE;
	const gchar* _tmp122_;
	GError* _inner_error0_ = NULL;
#line 104 "../src/lib/notification.vala"
	parent_class = G_OBJECT_CLASS (budgie_notification_parent_class);
#line 104 "../src/lib/notification.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 104 "../src/lib/notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 105 "../src/lib/notification.vala"
	variant = NULL;
#line 106 "../src/lib/notification.vala"
	_tmp0_ = g_time_zone_new_local ();
#line 106 "../src/lib/notification.vala"
	_tmp1_ = _tmp0_;
#line 106 "../src/lib/notification.vala"
	_tmp2_ = g_date_time_new_now (_tmp1_);
#line 106 "../src/lib/notification.vala"
	_tmp3_ = _tmp2_;
#line 106 "../src/lib/notification.vala"
	budgie_notification_set_timestamp (self, g_date_time_to_unix (_tmp3_));
#line 106 "../src/lib/notification.vala"
	_g_date_time_unref0 (_tmp3_);
#line 106 "../src/lib/notification.vala"
	_g_time_zone_unref0 (_tmp1_);
#line 109 "../src/lib/notification.vala"
	_tmp5_ = self->priv->_hints;
#line 109 "../src/lib/notification.vala"
	_tmp6_ = g_hash_table_lookup (_tmp5_, "urgency");
#line 109 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp6_;
#line 109 "../src/lib/notification.vala"
	_tmp7_ = variant;
#line 109 "../src/lib/notification.vala"
	if (_tmp7_ != NULL) {
#line 1640 "notification.c"
		GVariant* _tmp8_;
		const GVariantType* _tmp9_;
#line 109 "../src/lib/notification.vala"
		_tmp8_ = variant;
#line 109 "../src/lib/notification.vala"
		_tmp9_ = G_VARIANT_TYPE_BYTE;
#line 109 "../src/lib/notification.vala"
		_tmp4_ = g_variant_is_of_type (_tmp8_, _tmp9_);
#line 1649 "notification.c"
	} else {
#line 109 "../src/lib/notification.vala"
		_tmp4_ = FALSE;
#line 1653 "notification.c"
	}
#line 109 "../src/lib/notification.vala"
	if (_tmp4_) {
#line 1657 "notification.c"
		GVariant* _tmp10_;
#line 110 "../src/lib/notification.vala"
		_tmp10_ = variant;
#line 110 "../src/lib/notification.vala"
		budgie_notification_set_urgency (self, (GNotificationPriority) g_variant_get_byte (_tmp10_));
#line 1663 "notification.c"
	}
#line 114 "../src/lib/notification.vala"
	_tmp12_ = self->priv->_hints;
#line 114 "../src/lib/notification.vala"
	_tmp13_ = g_hash_table_lookup (_tmp12_, "category");
#line 114 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp13_;
#line 114 "../src/lib/notification.vala"
	_tmp14_ = variant;
#line 114 "../src/lib/notification.vala"
	if (_tmp14_ != NULL) {
#line 1675 "notification.c"
		GVariant* _tmp15_;
		const GVariantType* _tmp16_;
#line 114 "../src/lib/notification.vala"
		_tmp15_ = variant;
#line 114 "../src/lib/notification.vala"
		_tmp16_ = G_VARIANT_TYPE_STRING;
#line 114 "../src/lib/notification.vala"
		_tmp11_ = g_variant_is_of_type (_tmp15_, _tmp16_);
#line 1684 "notification.c"
	} else {
#line 114 "../src/lib/notification.vala"
		_tmp11_ = FALSE;
#line 1688 "notification.c"
	}
#line 114 "../src/lib/notification.vala"
	if (_tmp11_) {
#line 1692 "notification.c"
		GVariant* _tmp17_;
		const gchar* _tmp18_;
#line 115 "../src/lib/notification.vala"
		_tmp17_ = variant;
#line 115 "../src/lib/notification.vala"
		_tmp18_ = g_variant_get_string (_tmp17_, NULL);
#line 115 "../src/lib/notification.vala"
		budgie_notification_set_category (self, _tmp18_);
#line 1701 "notification.c"
	}
#line 119 "../src/lib/notification.vala"
	_tmp20_ = self->priv->_hints;
#line 119 "../src/lib/notification.vala"
	_tmp21_ = g_hash_table_lookup (_tmp20_, "desktop-entry");
#line 119 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp21_;
#line 119 "../src/lib/notification.vala"
	_tmp22_ = variant;
#line 119 "../src/lib/notification.vala"
	if (_tmp22_ != NULL) {
#line 1713 "notification.c"
		GVariant* _tmp23_;
		const GVariantType* _tmp24_;
#line 119 "../src/lib/notification.vala"
		_tmp23_ = variant;
#line 119 "../src/lib/notification.vala"
		_tmp24_ = G_VARIANT_TYPE_STRING;
#line 119 "../src/lib/notification.vala"
		_tmp19_ = g_variant_is_of_type (_tmp23_, _tmp24_);
#line 1722 "notification.c"
	} else {
#line 119 "../src/lib/notification.vala"
		_tmp19_ = FALSE;
#line 1726 "notification.c"
	}
#line 119 "../src/lib/notification.vala"
	if (_tmp19_) {
#line 1730 "notification.c"
		GVariant* _tmp25_;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		GDesktopAppInfo* _tmp33_;
		GDesktopAppInfo* _tmp34_;
		GDesktopAppInfo* _tmp35_;
#line 120 "../src/lib/notification.vala"
		_tmp25_ = variant;
#line 120 "../src/lib/notification.vala"
		_tmp26_ = g_variant_get_string (_tmp25_, NULL);
#line 120 "../src/lib/notification.vala"
		budgie_notification_set_app_id (self, _tmp26_);
#line 121 "../src/lib/notification.vala"
		_tmp27_ = self->priv->_app_id;
#line 121 "../src/lib/notification.vala"
		_tmp28_ = string_replace (_tmp27_, ".desktop", "");
#line 121 "../src/lib/notification.vala"
		_tmp29_ = _tmp28_;
#line 121 "../src/lib/notification.vala"
		_g_free0 (_tmp29_);
#line 122 "../src/lib/notification.vala"
		_tmp30_ = self->priv->_app_id;
#line 122 "../src/lib/notification.vala"
		_tmp31_ = g_strdup_printf ("%s.desktop", _tmp30_);
#line 122 "../src/lib/notification.vala"
		_tmp32_ = _tmp31_;
#line 122 "../src/lib/notification.vala"
		_tmp33_ = g_desktop_app_info_new (_tmp32_);
#line 122 "../src/lib/notification.vala"
		_tmp34_ = _tmp33_;
#line 122 "../src/lib/notification.vala"
		budgie_notification_set_app_info (self, _tmp34_);
#line 122 "../src/lib/notification.vala"
		_g_object_unref0 (_tmp34_);
#line 122 "../src/lib/notification.vala"
		_g_free0 (_tmp32_);
#line 124 "../src/lib/notification.vala"
		_tmp35_ = self->priv->_app_info;
#line 124 "../src/lib/notification.vala"
		if (_tmp35_ != NULL) {
#line 1776 "notification.c"
			gchar* _tmp36_ = NULL;
			GDesktopAppInfo* _tmp37_;
			gchar* _tmp38_;
#line 124 "../src/lib/notification.vala"
			_tmp37_ = self->priv->_app_info;
#line 124 "../src/lib/notification.vala"
			_tmp38_ = g_desktop_app_info_get_string (_tmp37_, "Name");
#line 124 "../src/lib/notification.vala"
			_tmp36_ = _tmp38_;
#line 124 "../src/lib/notification.vala"
			if (_tmp36_ == NULL) {
#line 1788 "notification.c"
				const gchar* _tmp39_;
				gchar* _tmp40_;
#line 124 "../src/lib/notification.vala"
				_tmp39_ = self->priv->_app_name;
#line 124 "../src/lib/notification.vala"
				_tmp40_ = g_strdup (_tmp39_);
#line 124 "../src/lib/notification.vala"
				_g_free0 (_tmp36_);
#line 124 "../src/lib/notification.vala"
				_tmp36_ = _tmp40_;
#line 1799 "notification.c"
			}
#line 124 "../src/lib/notification.vala"
			budgie_notification_set_app_name (self, _tmp36_);
#line 124 "../src/lib/notification.vala"
			_g_free0 (_tmp36_);
#line 1805 "notification.c"
		}
	}
#line 127 "../src/lib/notification.vala"
	_tmp41_ = self->priv->_app_id;
#line 127 "../src/lib/notification.vala"
	_tmp42_ = g_utf8_strdown (_tmp41_, (gssize) -1);
#line 127 "../src/lib/notification.vala"
	_tmp43_ = _tmp42_;
#line 127 "../src/lib/notification.vala"
	_tmp44_ = budgie_notification_get_appinfo_image (self, GTK_ICON_SIZE_DND, _tmp43_);
#line 127 "../src/lib/notification.vala"
	_tmp45_ = _tmp44_;
#line 127 "../src/lib/notification.vala"
	budgie_notification_set_app_image (self, _tmp45_);
#line 127 "../src/lib/notification.vala"
	_g_object_unref0 (_tmp45_);
#line 127 "../src/lib/notification.vala"
	_g_free0 (_tmp43_);
#line 129 "../src/lib/notification.vala"
	image_found = FALSE;
#line 133 "../src/lib/notification.vala"
	_tmp47_ = self->priv->_hints;
#line 133 "../src/lib/notification.vala"
	_tmp48_ = g_hash_table_lookup (_tmp47_, "image-data");
#line 133 "../src/lib/notification.vala"
	variant = (GVariant*) _tmp48_;
#line 133 "../src/lib/notification.vala"
	_tmp49_ = variant;
#line 133 "../src/lib/notification.vala"
	if (_tmp49_ != NULL) {
#line 133 "../src/lib/notification.vala"
		_tmp46_ = TRUE;
#line 1838 "notification.c"
	} else {
		GHashTable* _tmp50_;
		gconstpointer _tmp51_;
		GVariant* _tmp52_;
#line 134 "../src/lib/notification.vala"
		_tmp50_ = self->priv->_hints;
#line 134 "../src/lib/notification.vala"
		_tmp51_ = g_hash_table_lookup (_tmp50_, "image_data");
#line 134 "../src/lib/notification.vala"
		variant = (GVariant*) _tmp51_;
#line 134 "../src/lib/notification.vala"
		_tmp52_ = variant;
#line 134 "../src/lib/notification.vala"
		_tmp46_ = _tmp52_ != NULL;
#line 1853 "notification.c"
	}
#line 132 "../src/lib/notification.vala"
	if (_tmp46_) {
#line 1857 "notification.c"
		GdkPixbuf* pixbuf = NULL;
		GVariant* _tmp53_;
		GdkPixbuf* _tmp54_;
		GdkPixbuf* _tmp55_;
#line 136 "../src/lib/notification.vala"
		_tmp53_ = variant;
#line 136 "../src/lib/notification.vala"
		_tmp54_ = budgie_notification_decode_image (self, _tmp53_);
#line 136 "../src/lib/notification.vala"
		pixbuf = _tmp54_;
#line 137 "../src/lib/notification.vala"
		_tmp55_ = pixbuf;
#line 137 "../src/lib/notification.vala"
		if (_tmp55_ != NULL) {
#line 1872 "notification.c"
			GdkPixbuf* _tmp56_;
			GtkImage* _tmp57_;
			GtkImage* _tmp58_;
#line 138 "../src/lib/notification.vala"
			_tmp56_ = pixbuf;
#line 138 "../src/lib/notification.vala"
			_tmp57_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp56_);
#line 138 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp57_);
#line 138 "../src/lib/notification.vala"
			_tmp58_ = _tmp57_;
#line 138 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp58_);
#line 138 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp58_);
#line 139 "../src/lib/notification.vala"
			image_found = TRUE;
#line 1890 "notification.c"
		}
#line 132 "../src/lib/notification.vala"
		_g_object_unref0 (pixbuf);
#line 1894 "notification.c"
	}
#line 144 "../src/lib/notification.vala"
	if (!image_found) {
#line 1898 "notification.c"
		gboolean _tmp60_ = FALSE;
		GHashTable* _tmp61_;
		gconstpointer _tmp62_;
		GVariant* _tmp63_;
#line 145 "../src/lib/notification.vala"
		_tmp61_ = self->priv->_hints;
#line 145 "../src/lib/notification.vala"
		_tmp62_ = g_hash_table_lookup (_tmp61_, "image-path");
#line 145 "../src/lib/notification.vala"
		variant = (GVariant*) _tmp62_;
#line 145 "../src/lib/notification.vala"
		_tmp63_ = variant;
#line 145 "../src/lib/notification.vala"
		if (_tmp63_ != NULL) {
#line 146 "../src/lib/notification.vala"
			_tmp60_ = TRUE;
#line 1915 "notification.c"
		} else {
			GHashTable* _tmp64_;
			gconstpointer _tmp65_;
			GVariant* _tmp66_;
#line 147 "../src/lib/notification.vala"
			_tmp64_ = self->priv->_hints;
#line 147 "../src/lib/notification.vala"
			_tmp65_ = g_hash_table_lookup (_tmp64_, "image_path");
#line 147 "../src/lib/notification.vala"
			variant = (GVariant*) _tmp65_;
#line 147 "../src/lib/notification.vala"
			_tmp66_ = variant;
#line 147 "../src/lib/notification.vala"
			_tmp60_ = _tmp66_ != NULL;
#line 1930 "notification.c"
		}
#line 145 "../src/lib/notification.vala"
		_tmp59_ = _tmp60_;
#line 1934 "notification.c"
	} else {
#line 144 "../src/lib/notification.vala"
		_tmp59_ = FALSE;
#line 1938 "notification.c"
	}
#line 144 "../src/lib/notification.vala"
	if (_tmp59_) {
#line 1942 "notification.c"
		gchar* path = NULL;
		GVariant* _tmp67_;
		const gchar* _tmp68_;
		gchar* _tmp69_;
		gboolean _tmp70_ = FALSE;
		GtkIconTheme* _tmp71_;
		const gchar* _tmp72_;
#line 150 "../src/lib/notification.vala"
		_tmp67_ = variant;
#line 150 "../src/lib/notification.vala"
		_tmp68_ = g_variant_get_string (_tmp67_, NULL);
#line 150 "../src/lib/notification.vala"
		_tmp69_ = g_strdup (_tmp68_);
#line 150 "../src/lib/notification.vala"
		path = _tmp69_;
#line 152 "../src/lib/notification.vala"
		_tmp71_ = gtk_icon_theme_get_default ();
#line 152 "../src/lib/notification.vala"
		_tmp72_ = path;
#line 152 "../src/lib/notification.vala"
		if (gtk_icon_theme_has_icon (_tmp71_, _tmp72_)) {
#line 1964 "notification.c"
			const gchar* _tmp73_;
			const gchar* _tmp74_;
#line 152 "../src/lib/notification.vala"
			_tmp73_ = path;
#line 152 "../src/lib/notification.vala"
			_tmp74_ = self->priv->_notification_icon;
#line 152 "../src/lib/notification.vala"
			_tmp70_ = g_strcmp0 (_tmp73_, _tmp74_) != 0;
#line 1973 "notification.c"
		} else {
#line 152 "../src/lib/notification.vala"
			_tmp70_ = FALSE;
#line 1977 "notification.c"
		}
#line 152 "../src/lib/notification.vala"
		if (_tmp70_) {
#line 1981 "notification.c"
			GThemedIcon* icon = NULL;
			const gchar* _tmp75_;
			GThemedIcon* _tmp76_;
			GThemedIcon* _tmp77_;
			GtkImage* _tmp78_;
			GtkImage* _tmp79_;
#line 153 "../src/lib/notification.vala"
			_tmp75_ = path;
#line 153 "../src/lib/notification.vala"
			_tmp76_ = (GThemedIcon*) g_themed_icon_new (_tmp75_);
#line 153 "../src/lib/notification.vala"
			icon = _tmp76_;
#line 154 "../src/lib/notification.vala"
			_tmp77_ = icon;
#line 154 "../src/lib/notification.vala"
			_tmp78_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp77_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 154 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp78_);
#line 154 "../src/lib/notification.vala"
			_tmp79_ = _tmp78_;
#line 154 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp79_);
#line 154 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp79_);
#line 155 "../src/lib/notification.vala"
			image_found = TRUE;
#line 152 "../src/lib/notification.vala"
			_g_object_unref0 (icon);
#line 2010 "notification.c"
		} else {
			gboolean _tmp80_ = FALSE;
			const gchar* _tmp81_;
#line 156 "../src/lib/notification.vala"
			_tmp81_ = path;
#line 156 "../src/lib/notification.vala"
			if (g_str_has_prefix (_tmp81_, "/")) {
#line 156 "../src/lib/notification.vala"
				_tmp80_ = TRUE;
#line 2020 "notification.c"
			} else {
				const gchar* _tmp82_;
#line 156 "../src/lib/notification.vala"
				_tmp82_ = path;
#line 156 "../src/lib/notification.vala"
				_tmp80_ = g_str_has_prefix (_tmp82_, "file://");
#line 2027 "notification.c"
			}
#line 156 "../src/lib/notification.vala"
			if (_tmp80_) {
#line 2031 "notification.c"
				{
					GdkPixbuf* pixbuf = NULL;
					const gchar* _tmp83_;
					GdkPixbuf* _tmp84_;
					GdkPixbuf* _tmp85_;
					GtkImage* _tmp86_;
					GtkImage* _tmp87_;
#line 158 "../src/lib/notification.vala"
					_tmp83_ = path;
#line 158 "../src/lib/notification.vala"
					_tmp84_ = gdk_pixbuf_new_from_file_at_size (_tmp83_, 48, 48, &_inner_error0_);
#line 158 "../src/lib/notification.vala"
					pixbuf = _tmp84_;
#line 158 "../src/lib/notification.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2047 "notification.c"
						goto __catch0_g_error;
					}
#line 159 "../src/lib/notification.vala"
					_tmp85_ = pixbuf;
#line 159 "../src/lib/notification.vala"
					_tmp86_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp85_);
#line 159 "../src/lib/notification.vala"
					g_object_ref_sink (_tmp86_);
#line 159 "../src/lib/notification.vala"
					_tmp87_ = _tmp86_;
#line 159 "../src/lib/notification.vala"
					budgie_notification_set_image (self, _tmp87_);
#line 159 "../src/lib/notification.vala"
					_g_object_unref0 (_tmp87_);
#line 160 "../src/lib/notification.vala"
					image_found = TRUE;
#line 157 "../src/lib/notification.vala"
					_g_object_unref0 (pixbuf);
#line 2066 "notification.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp88_;
					const gchar* _tmp89_;
#line 157 "../src/lib/notification.vala"
					e = _inner_error0_;
#line 157 "../src/lib/notification.vala"
					_inner_error0_ = NULL;
#line 162 "../src/lib/notification.vala"
					_tmp88_ = e;
#line 162 "../src/lib/notification.vala"
					_tmp89_ = _tmp88_->message;
#line 162 "../src/lib/notification.vala"
					g_critical ("notification.vala:162: Unable to get pixbuf from path: %s", _tmp89_);
#line 157 "../src/lib/notification.vala"
					_g_error_free0 (e);
#line 2086 "notification.c"
				}
				__finally0:
#line 157 "../src/lib/notification.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "../src/lib/notification.vala"
					_g_free0 (path);
#line 157 "../src/lib/notification.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 157 "../src/lib/notification.vala"
					g_clear_error (&_inner_error0_);
#line 2097 "notification.c"
				}
			}
		}
#line 144 "../src/lib/notification.vala"
		_g_free0 (path);
#line 2103 "notification.c"
	}
#line 168 "../src/lib/notification.vala"
	if (!image_found) {
#line 2107 "notification.c"
		gboolean _tmp90_ = FALSE;
		const gchar* _tmp91_;
#line 169 "../src/lib/notification.vala"
		_tmp91_ = self->priv->_notification_icon;
#line 169 "../src/lib/notification.vala"
		if (g_strcmp0 (_tmp91_, "") != 0) {
#line 2114 "notification.c"
			const gchar* _tmp92_;
#line 169 "../src/lib/notification.vala"
			_tmp92_ = self->priv->_notification_icon;
#line 169 "../src/lib/notification.vala"
			_tmp90_ = !string_contains (_tmp92_, "/");
#line 2120 "notification.c"
		} else {
#line 169 "../src/lib/notification.vala"
			_tmp90_ = FALSE;
#line 2124 "notification.c"
		}
#line 169 "../src/lib/notification.vala"
		if (_tmp90_) {
#line 2128 "notification.c"
			const gchar* _tmp93_;
			GtkImage* _tmp94_;
			GtkImage* _tmp95_;
#line 170 "../src/lib/notification.vala"
			_tmp93_ = self->priv->_notification_icon;
#line 170 "../src/lib/notification.vala"
			_tmp94_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp93_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 170 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp94_);
#line 170 "../src/lib/notification.vala"
			_tmp95_ = _tmp94_;
#line 170 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp95_);
#line 170 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp95_);
#line 171 "../src/lib/notification.vala"
			image_found = TRUE;
#line 2146 "notification.c"
		} else {
			gboolean _tmp96_ = FALSE;
			const gchar* _tmp97_;
#line 172 "../src/lib/notification.vala"
			_tmp97_ = self->priv->_notification_icon;
#line 172 "../src/lib/notification.vala"
			if (g_strcmp0 (_tmp97_, "") == 0) {
#line 2154 "notification.c"
				GDesktopAppInfo* _tmp98_;
#line 172 "../src/lib/notification.vala"
				_tmp98_ = self->priv->_app_info;
#line 172 "../src/lib/notification.vala"
				_tmp96_ = _tmp98_ != NULL;
#line 2160 "notification.c"
			} else {
#line 172 "../src/lib/notification.vala"
				_tmp96_ = FALSE;
#line 2164 "notification.c"
			}
#line 172 "../src/lib/notification.vala"
			if (_tmp96_) {
#line 2168 "notification.c"
				GtkImage* _tmp99_;
				GtkImage* _tmp100_;
#line 173 "../src/lib/notification.vala"
				_tmp99_ = budgie_notification_get_appinfo_image (self, GTK_ICON_SIZE_DIALOG, "mail-unread-symbolic");
#line 173 "../src/lib/notification.vala"
				_tmp100_ = _tmp99_;
#line 173 "../src/lib/notification.vala"
				budgie_notification_set_image (self, _tmp100_);
#line 173 "../src/lib/notification.vala"
				_g_object_unref0 (_tmp100_);
#line 174 "../src/lib/notification.vala"
				image_found = TRUE;
#line 2181 "notification.c"
			} else {
				const gchar* _tmp101_;
#line 175 "../src/lib/notification.vala"
				_tmp101_ = self->priv->_notification_icon;
#line 175 "../src/lib/notification.vala"
				if (string_contains (_tmp101_, "/")) {
#line 2188 "notification.c"
					GFile* file = NULL;
					const gchar* _tmp102_;
					GFile* _tmp103_;
					GFile* _tmp104_;
#line 176 "../src/lib/notification.vala"
					_tmp102_ = self->priv->_notification_icon;
#line 176 "../src/lib/notification.vala"
					_tmp103_ = g_file_new_for_uri (_tmp102_);
#line 176 "../src/lib/notification.vala"
					file = _tmp103_;
#line 177 "../src/lib/notification.vala"
					_tmp104_ = file;
#line 177 "../src/lib/notification.vala"
					if (g_file_query_exists (_tmp104_, NULL)) {
#line 2203 "notification.c"
						GFileIcon* icon = NULL;
						GFile* _tmp105_;
						GFileIcon* _tmp106_;
						GFileIcon* _tmp107_;
						GtkImage* _tmp108_;
						GtkImage* _tmp109_;
#line 178 "../src/lib/notification.vala"
						_tmp105_ = file;
#line 178 "../src/lib/notification.vala"
						_tmp106_ = (GFileIcon*) g_file_icon_new (_tmp105_);
#line 178 "../src/lib/notification.vala"
						icon = _tmp106_;
#line 179 "../src/lib/notification.vala"
						_tmp107_ = icon;
#line 179 "../src/lib/notification.vala"
						_tmp108_ = (GtkImage*) gtk_image_new_from_gicon ((GIcon*) _tmp107_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 179 "../src/lib/notification.vala"
						g_object_ref_sink (_tmp108_);
#line 179 "../src/lib/notification.vala"
						_tmp109_ = _tmp108_;
#line 179 "../src/lib/notification.vala"
						budgie_notification_set_image (self, _tmp109_);
#line 179 "../src/lib/notification.vala"
						_g_object_unref0 (_tmp109_);
#line 180 "../src/lib/notification.vala"
						image_found = TRUE;
#line 177 "../src/lib/notification.vala"
						_g_object_unref0 (icon);
#line 2232 "notification.c"
					}
#line 175 "../src/lib/notification.vala"
					_g_object_unref0 (file);
#line 2236 "notification.c"
				}
			}
		}
	}
#line 186 "../src/lib/notification.vala"
	if (!image_found) {
#line 2243 "notification.c"
		GHashTable* _tmp111_;
		gconstpointer _tmp112_;
		GVariant* _tmp113_;
#line 186 "../src/lib/notification.vala"
		_tmp111_ = self->priv->_hints;
#line 186 "../src/lib/notification.vala"
		_tmp112_ = g_hash_table_lookup (_tmp111_, "icon_data");
#line 186 "../src/lib/notification.vala"
		variant = (GVariant*) _tmp112_;
#line 186 "../src/lib/notification.vala"
		_tmp113_ = variant;
#line 186 "../src/lib/notification.vala"
		_tmp110_ = _tmp113_ != NULL;
#line 2257 "notification.c"
	} else {
#line 186 "../src/lib/notification.vala"
		_tmp110_ = FALSE;
#line 2261 "notification.c"
	}
#line 186 "../src/lib/notification.vala"
	if (_tmp110_) {
#line 2265 "notification.c"
		GdkPixbuf* pixbuf = NULL;
		GVariant* _tmp114_;
		GdkPixbuf* _tmp115_;
		GdkPixbuf* _tmp116_;
#line 187 "../src/lib/notification.vala"
		_tmp114_ = variant;
#line 187 "../src/lib/notification.vala"
		_tmp115_ = budgie_notification_decode_image (self, _tmp114_);
#line 187 "../src/lib/notification.vala"
		pixbuf = _tmp115_;
#line 188 "../src/lib/notification.vala"
		_tmp116_ = pixbuf;
#line 188 "../src/lib/notification.vala"
		if (_tmp116_ != NULL) {
#line 2280 "notification.c"
			GdkPixbuf* _tmp117_;
			GtkImage* _tmp118_;
			GtkImage* _tmp119_;
#line 189 "../src/lib/notification.vala"
			_tmp117_ = pixbuf;
#line 189 "../src/lib/notification.vala"
			_tmp118_ = (GtkImage*) gtk_image_new_from_pixbuf (_tmp117_);
#line 189 "../src/lib/notification.vala"
			g_object_ref_sink (_tmp118_);
#line 189 "../src/lib/notification.vala"
			_tmp119_ = _tmp118_;
#line 189 "../src/lib/notification.vala"
			budgie_notification_set_image (self, _tmp119_);
#line 189 "../src/lib/notification.vala"
			_g_object_unref0 (_tmp119_);
#line 190 "../src/lib/notification.vala"
			image_found = TRUE;
#line 2298 "notification.c"
		}
#line 186 "../src/lib/notification.vala"
		_g_object_unref0 (pixbuf);
#line 2302 "notification.c"
	}
#line 195 "../src/lib/notification.vala"
	if (!image_found) {
#line 2306 "notification.c"
		GtkImage* _tmp120_;
		GtkImage* _tmp121_;
#line 196 "../src/lib/notification.vala"
		_tmp120_ = (GtkImage*) gtk_image_new_from_icon_name ("mail-unread-symbolic", (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 196 "../src/lib/notification.vala"
		g_object_ref_sink (_tmp120_);
#line 196 "../src/lib/notification.vala"
		_tmp121_ = _tmp120_;
#line 196 "../src/lib/notification.vala"
		budgie_notification_set_image (self, _tmp121_);
#line 196 "../src/lib/notification.vala"
		_g_object_unref0 (_tmp121_);
#line 2319 "notification.c"
	}
#line 201 "../src/lib/notification.vala"
	_tmp122_ = self->priv->_body;
#line 201 "../src/lib/notification.vala"
	if (g_strcmp0 (_tmp122_, "") == 0) {
#line 2325 "notification.c"
		const gchar* _tmp123_;
		gchar* _tmp124_;
		gchar* _tmp125_;
		const gchar* _tmp126_;
#line 202 "../src/lib/notification.vala"
		_tmp123_ = self->priv->_summary;
#line 202 "../src/lib/notification.vala"
		_tmp124_ = budgie_notification_fix_markup (self, _tmp123_);
#line 202 "../src/lib/notification.vala"
		_tmp125_ = _tmp124_;
#line 202 "../src/lib/notification.vala"
		budgie_notification_set_body (self, _tmp125_);
#line 202 "../src/lib/notification.vala"
		_g_free0 (_tmp125_);
#line 203 "../src/lib/notification.vala"
		_tmp126_ = self->priv->_app_name;
#line 203 "../src/lib/notification.vala"
		budgie_notification_set_summary (self, _tmp126_);
#line 2344 "notification.c"
	} else {
		const gchar* _tmp127_;
		gchar* _tmp128_;
		gchar* _tmp129_;
		const gchar* _tmp130_;
		gchar* _tmp131_;
		gchar* _tmp132_;
#line 205 "../src/lib/notification.vala"
		_tmp127_ = self->priv->_body;
#line 205 "../src/lib/notification.vala"
		_tmp128_ = budgie_notification_fix_markup (self, _tmp127_);
#line 205 "../src/lib/notification.vala"
		_tmp129_ = _tmp128_;
#line 205 "../src/lib/notification.vala"
		budgie_notification_set_body (self, _tmp129_);
#line 205 "../src/lib/notification.vala"
		_g_free0 (_tmp129_);
#line 206 "../src/lib/notification.vala"
		_tmp130_ = self->priv->_summary;
#line 206 "../src/lib/notification.vala"
		_tmp131_ = budgie_notification_fix_markup (self, _tmp130_);
#line 206 "../src/lib/notification.vala"
		_tmp132_ = _tmp131_;
#line 206 "../src/lib/notification.vala"
		budgie_notification_set_summary (self, _tmp132_);
#line 206 "../src/lib/notification.vala"
		_g_free0 (_tmp132_);
#line 2372 "notification.c"
	}
#line 104 "../src/lib/notification.vala"
	return obj;
#line 2376 "notification.c"
}

static void
budgie_notification_class_init (BudgieNotificationClass * klass,
                                gpointer klass_data)
{
	GError* _inner_error0_ = NULL;
#line 41 "../src/lib/notification.vala"
	budgie_notification_parent_class = g_type_class_peek_parent (klass);
#line 41 "../src/lib/notification.vala"
	g_type_class_adjust_private_offset (klass, &BudgieNotification_private_offset);
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_budgie_notification_get_property;
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_budgie_notification_set_property;
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->constructor = budgie_notification_constructor;
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (klass)->finalize = budgie_notification_finalize;
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_INFO_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_INFO_PROPERTY] = g_param_spec_object ("app-info", "app-info", "app-info", G_TYPE_DESKTOP_APP_INFO, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_ID_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_URGENCY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_URGENCY_PROPERTY] = g_param_spec_enum ("urgency", "urgency", "urgency", g_notification_priority_get_type (), G_NOTIFICATION_PRIORITY_NORMAL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_ID_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_ID_PROPERTY] = g_param_spec_uint ("id", "id", "id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_NAME_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_NAME_PROPERTY] = g_param_spec_string ("app-name", "app-name", "app-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_NOTIFICATION_ICON_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_NOTIFICATION_ICON_PROPERTY] = g_param_spec_string ("notification-icon", "notification-icon", "notification-icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_HINTS_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_HINTS_PROPERTY] = g_param_spec_boxed ("hints", "hints", "hints", G_TYPE_HASH_TABLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_ACTIONS_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_ACTIONS_PROPERTY] = g_param_spec_boxed ("actions", "actions", "actions", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_BODY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_BODY_PROPERTY] = g_param_spec_string ("body", "body", "body", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_SUMMARY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_SUMMARY_PROPERTY] = g_param_spec_string ("summary", "summary", "summary", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY] = g_param_spec_uint ("expire-timeout", "expire-timeout", "expire-timeout", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_CATEGORY_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_CATEGORY_PROPERTY] = g_param_spec_string ("category", "category", "category", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY] = g_param_spec_int64 ("timestamp", "timestamp", "timestamp", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_APP_IMAGE_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_APP_IMAGE_PROPERTY] = g_param_spec_object ("app-image", "app-image", "app-image", gtk_image_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 41 "../src/lib/notification.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BUDGIE_NOTIFICATION_IMAGE_PROPERTY, budgie_notification_properties[BUDGIE_NOTIFICATION_IMAGE_PROPERTY] = g_param_spec_object ("image", "image", "image", gtk_image_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2426 "notification.c"
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_;
		GRegex* _tmp5_;
#line 97 "../src/lib/notification.vala"
		_tmp1_ = g_regex_new ("&(?!amp;|quot;|apos;|lt;|gt;|#39;|nbsp;)", 0, 0, &_inner_error0_);
#line 97 "../src/lib/notification.vala"
		_tmp0_ = _tmp1_;
#line 97 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2440 "notification.c"
			goto __catch0_g_error;
		}
#line 97 "../src/lib/notification.vala"
		_tmp2_ = _tmp0_;
#line 97 "../src/lib/notification.vala"
		_tmp0_ = NULL;
#line 97 "../src/lib/notification.vala"
		_g_regex_unref0 (budgie_notification_entity_regex);
#line 97 "../src/lib/notification.vala"
		budgie_notification_entity_regex = _tmp2_;
#line 98 "../src/lib/notification.vala"
		_tmp4_ = g_regex_new ("<(?!\\/?[biu]>)", 0, 0, &_inner_error0_);
#line 98 "../src/lib/notification.vala"
		_tmp3_ = _tmp4_;
#line 98 "../src/lib/notification.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "../src/lib/notification.vala"
			_g_regex_unref0 (_tmp0_);
#line 2459 "notification.c"
			goto __catch0_g_error;
		}
#line 98 "../src/lib/notification.vala"
		_tmp5_ = _tmp3_;
#line 98 "../src/lib/notification.vala"
		_tmp3_ = NULL;
#line 98 "../src/lib/notification.vala"
		_g_regex_unref0 (budgie_notification_tag_regex);
#line 98 "../src/lib/notification.vala"
		budgie_notification_tag_regex = _tmp5_;
#line 96 "../src/lib/notification.vala"
		_g_regex_unref0 (_tmp3_);
#line 96 "../src/lib/notification.vala"
		_g_regex_unref0 (_tmp0_);
#line 2474 "notification.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 96 "../src/lib/notification.vala"
		e = _inner_error0_;
#line 96 "../src/lib/notification.vala"
		_inner_error0_ = NULL;
#line 100 "../src/lib/notification.vala"
		_tmp6_ = e;
#line 100 "../src/lib/notification.vala"
		_tmp7_ = _tmp6_->message;
#line 100 "../src/lib/notification.vala"
		g_warning ("notification.vala:100: Invalid notification regex: %s", _tmp7_);
#line 96 "../src/lib/notification.vala"
		_g_error_free0 (e);
#line 2494 "notification.c"
	}
	__finally0:
#line 96 "../src/lib/notification.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 96 "../src/lib/notification.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 96 "../src/lib/notification.vala"
		g_clear_error (&_inner_error0_);
#line 2503 "notification.c"
	}
}

static void
budgie_notification_instance_init (BudgieNotification * self,
                                   gpointer klass)
{
#line 41 "../src/lib/notification.vala"
	self->priv = budgie_notification_get_instance_private (self);
#line 42 "../src/lib/notification.vala"
	self->priv->_app_info = NULL;
#line 44 "../src/lib/notification.vala"
	self->priv->_urgency = G_NOTIFICATION_PRIORITY_NORMAL;
#line 61 "../src/lib/notification.vala"
	self->priv->_app_image = NULL;
#line 62 "../src/lib/notification.vala"
	self->priv->_image = NULL;
#line 2521 "notification.c"
}

static void
budgie_notification_finalize (GObject * obj)
{
	BudgieNotification * self;
#line 41 "../src/lib/notification.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 42 "../src/lib/notification.vala"
	_g_object_unref0 (self->priv->_app_info);
#line 43 "../src/lib/notification.vala"
	_g_free0 (self->priv->_app_id);
#line 49 "../src/lib/notification.vala"
	_g_free0 (self->priv->_app_name);
#line 50 "../src/lib/notification.vala"
	_g_free0 (self->priv->_notification_icon);
#line 51 "../src/lib/notification.vala"
	_g_hash_table_unref0 (self->priv->_hints);
#line 52 "../src/lib/notification.vala"
	self->priv->_actions = (_vala_array_free (self->priv->_actions, self->priv->_actions_length1, (GDestroyNotify) g_free), NULL);
#line 53 "../src/lib/notification.vala"
	_g_free0 (self->priv->_body);
#line 54 "../src/lib/notification.vala"
	_g_free0 (self->priv->_summary);
#line 57 "../src/lib/notification.vala"
	_g_free0 (self->priv->_category);
#line 61 "../src/lib/notification.vala"
	_g_object_unref0 (self->priv->_app_image);
#line 62 "../src/lib/notification.vala"
	_g_object_unref0 (self->priv->_image);
#line 41 "../src/lib/notification.vala"
	G_OBJECT_CLASS (budgie_notification_parent_class)->finalize (obj);
#line 2554 "notification.c"
}

/**
 * This is our wrapper class for a FreeDesktop notification.
 */
static GType
budgie_notification_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BudgieNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) budgie_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BudgieNotification), 0, (GInstanceInitFunc) budgie_notification_instance_init, NULL };
	GType budgie_notification_type_id;
	budgie_notification_type_id = g_type_register_static (G_TYPE_OBJECT, "BudgieNotification", &g_define_type_info, 0);
	BudgieNotification_private_offset = g_type_add_instance_private (budgie_notification_type_id, sizeof (BudgieNotificationPrivate));
	return budgie_notification_type_id;
}

GType
budgie_notification_get_type (void)
{
	static volatile gsize budgie_notification_type_id__once = 0;
	if (g_once_init_enter (&budgie_notification_type_id__once)) {
		GType budgie_notification_type_id;
		budgie_notification_type_id = budgie_notification_get_type_once ();
		g_once_init_leave (&budgie_notification_type_id__once, budgie_notification_type_id);
	}
	return budgie_notification_type_id__once;
}

static void
_vala_budgie_notification_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	BudgieNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 41 "../src/lib/notification.vala"
	switch (property_id) {
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_INFO_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_object (value, budgie_notification_get_app_info (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_ID_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_app_id (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_URGENCY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_enum (value, budgie_notification_get_urgency (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ID_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_uint (value, budgie_notification_get_id (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_NAME_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_app_name (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_NOTIFICATION_ICON_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_notification_icon (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_HINTS_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_boxed (value, budgie_notification_get_hints (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ACTIONS_PROPERTY:
#line 2636 "notification.c"
		{
			int length;
#line 41 "../src/lib/notification.vala"
			g_value_set_boxed (value, budgie_notification_get_actions (self, &length));
#line 2641 "notification.c"
		}
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_BODY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_body (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_SUMMARY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_summary (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_uint (value, budgie_notification_get_expire_timeout (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_CATEGORY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_string (value, budgie_notification_get_category (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_int64 (value, budgie_notification_get_timestamp (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_IMAGE_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_object (value, budgie_notification_get_app_image (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_IMAGE_PROPERTY:
#line 41 "../src/lib/notification.vala"
		g_value_set_object (value, budgie_notification_get_image (self));
#line 41 "../src/lib/notification.vala"
		break;
#line 2687 "notification.c"
		default:
#line 41 "../src/lib/notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../src/lib/notification.vala"
		break;
#line 2693 "notification.c"
	}
}

static void
_vala_budgie_notification_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	BudgieNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BUDGIE_TYPE_NOTIFICATION, BudgieNotification);
#line 41 "../src/lib/notification.vala"
	switch (property_id) {
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_INFO_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_app_info (self, g_value_get_object (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_ID_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_app_id (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_URGENCY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_urgency (self, g_value_get_enum (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ID_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_id (self, g_value_get_uint (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_NAME_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_app_name (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_NOTIFICATION_ICON_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_notification_icon (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_HINTS_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_hints (self, g_value_get_boxed (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_ACTIONS_PROPERTY:
#line 2751 "notification.c"
		{
			gpointer boxed;
#line 41 "../src/lib/notification.vala"
			boxed = g_value_get_boxed (value);
#line 41 "../src/lib/notification.vala"
			budgie_notification_set_actions (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 2758 "notification.c"
		}
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_BODY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_body (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_SUMMARY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_summary (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_EXPIRE_TIMEOUT_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_expire_timeout (self, g_value_get_uint (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_CATEGORY_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_category (self, g_value_get_string (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_TIMESTAMP_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_timestamp (self, g_value_get_int64 (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_APP_IMAGE_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_app_image (self, g_value_get_object (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 41 "../src/lib/notification.vala"
		case BUDGIE_NOTIFICATION_IMAGE_PROPERTY:
#line 41 "../src/lib/notification.vala"
		budgie_notification_set_image (self, g_value_get_object (value));
#line 41 "../src/lib/notification.vala"
		break;
#line 2804 "notification.c"
		default:
#line 41 "../src/lib/notification.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../src/lib/notification.vala"
		break;
#line 2810 "notification.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

